// K3-10@`FCnbVChainHash̗piL[͎j

#include <stdio.h>
#include "Member.h"
#include "ChainHash.h"

/*--- j[ ---*/
typedef enum {
	TERMINATE, ADD, DELETE, SEARCH, CLEAR, DUMP
} Menu;

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int ch;

	do {
		printf("(1)ǉ (2)폜 (3)T (4)S폜 (5)_v (0)IF");
		scanf("%d", &ch);
	} while (ch < TERMINATE || ch > DUMP);
	return (Menu)ch;
}

/*--- C ---*/
int main(void)
{
	Menu menu;				// j[
	ChainHash hash;			// nbV\

	Initialize(&hash, 13);	// nbV\̏

	do {
		int result;
		Member x;
		Node *temp;

		switch (menu = SelectMenu()) {
		 case ADD : /*--- f[^̒ǉ ---*/
				x = ScanMember("ǉ", MEMBER_NO | MEMBER_NAME);
				result = Add(&hash, &x);
				if (result)
					printf("\aG[FǉɎs܂i%sjB\n",
							(result == 1) ? "o^" : "s");
				break;

		 case DELETE : /*--- f[^̍폜 ---*/
				x = ScanMember("폜", MEMBER_NAME);
				result = Remove(&hash, &x);
				if (result == 1)
					printf("\aG[F̔ԍ̃f[^݂͑܂B\n");
				break;

		 case SEARCH : /*--- f[^̒T ---*/
				x = ScanMember("T", MEMBER_NAME);
				temp = Search(&hash, &x);
				if (temp == NULL)
					printf("\aTɎs܂B\n");
				else {
					printf("Tɐ܂F");
					PrintLnMember(&temp->data);
				}
				break;

		 case CLEAR : /*--- Sf[^̍폜 ---*/
				Clear(&hash);
				break;

		 case DUMP : /*--- nbV\̃_v ---*/
				Dump(&hash);
				break;
		}
	} while (menu != TERMINATE);

	Terminate(&hash);							// nbV\̌n

	return 0;
}
