// K6-14@NCbN\[givf̃O[vDIɕFċAŁj

// {vÕRpCɂ"IntStack.h""IntStack.c"Kvł

#include <stdio.h>
#include <stdlib.h>
#include "IntStack.h"

#define swap(type, x, y) do { type t = x; x = y; y = t; } while (0)

/*--- NCbN\[giċAŁFvf̃O[vDIɕj---*/
void quick(int a[], int left, int right)
{
	IntStack lstack;		// ׂ擪vf̓ỸX^bN
	IntStack rstack;		// ׂvf̓ỸX^bN

	Initialize(&lstack, right - left + 1);
	Initialize(&rstack, right - left + 1);

	Push(&lstack, left);
	Push(&rstack, right);

	while (!IsEmpty(&lstack)) {
		int pl = (Pop(&lstack, &left),  left);		// J[\
		int pr = (Pop(&rstack, &right), right);		// EJ[\
		int x = a[(left + right) / 2];				// ̗͒vf

		do {
			while (a[pl] < x) pl++;
			while (a[pr] > x) pr--;
			if (pl <= pr) {
				swap(int, a[pl], a[pr]);
				pl++;
				pr--;
			}
		} while (pl <= pr);

		if (pr - left < right - pl) {
			swap(int, pl, left);
			swap(int, pr, right);
		}
		if (left < pr) {
			Push(&lstack, left);	// O[v͈̔͂
			Push(&rstack, pr);		// YvbV
		}
		if (pl < right) {
			Push(&lstack, pl);		// EO[v͈̔͂
			Push(&rstack, right);	// YvbV
		}
	}
	Terminate(&lstack);
	Terminate(&rstack);
}

int main(void)
{
	int nx;

	puts("NCbN\[g");
	printf("vf : ");
	scanf("%d", &nx);
	int *x = calloc(nx, sizeof(int));	// vfnxint^zx𐶐

	for (int i = 0; i < nx; i++) {
		printf("x[%d] : ", i);
		scanf("%d", &x[i]);
	}

	quick(x, 0, nx - 1);				// zxNCbN\[g

	puts("Ƀ\[g܂B");
	for (int i = 0; i < nx; i++)
		printf("x[%d] = %d\n", i, x[i]);

	free(x);							// zxj

	return 0;
}
