// I[vAhX@ɂnbViwb_j

#ifndef ___ClosedHash
#define ___ClosedHash

#include "Member.h"

/*--- vf̏ ---*/
typedef enum {
	Occupied, Empty, Deleted
} Status;

/*--- vf ---*/
typedef struct {
	Member data;		// f[^
	Status stat;		// vf̏
} Bucket;

/*--- nbV\ ---*/
typedef struct {
	int     size;		// nbV\̑傫
	Bucket *table;		// nbV\̐擪vfւ̃|C^
} ClosedHash;

/*--- nbV\ ---*/
int Initialize(ClosedHash *h, int size);

/*--- T ---*/
Bucket *Search(const ClosedHash *h, const Member *x);

/*--- f[^̒ǉ ---*/
int Add(ClosedHash *h, const Member *x);

/*--- f[^̍폜 ---*/
int Remove(ClosedHash *h, const Member *x);

/*--- nbV\_v ---*/
void Dump(const ClosedHash *h);

/*--- Sf[^̍폜 ---*/
void Clear(ClosedHash *h);

/*--- nbV\n ---*/
void Terminate(ClosedHash *h);

#endif
