// K8-3 J[\ɂ`Xgiwb_j

#ifndef ___ArrayLinkedList
#define ___ArrayLinkedList

#include "Member.h"

#define Null	-1			// J[\

typedef int Index;			// J[\^

/*--- m[h ---*/
typedef struct {
	Member data;			// f[^
	Index next;				// 㑱J[\
	Index Dnext;			// t[Xǧ㑱J[\
} Node;

/*--- `Xg ---*/
typedef struct {
	Node* n;				// Xg{́izj
	Index head;				// 擪J[\
	Index max;				// p̖R[h
	Index deleted;			// t[Xg̐擪J[\
	Index crnt;				// ڃJ[\
} List;

/*--- `Xgiővfsizej---*/
void Initialize(List *list, int size);

/*--- ֐compareɂxƈvƔ肳m[hT ---*/
Index Search(List *list, const Member *x,
						 int compare(const Member *x, const Member *y));

/*--- 擪n̃m[hւ̃J[\擾 ---*/
Index Retrieve(List *list, int n);

/*--- 擪Ƀm[h} ---*/
void InsertFront(List *list, const Member *x);

/*--- Ƀm[h} ---*/
void InsertRear(List *list, const Member *x);

/*--- 擪m[h폜 ---*/
void RemoveFront(List *list);

/*--- m[h폜 ---*/
void RemoveRear(List *list);

/*--- ڃm[h폜 ---*/
void RemoveCurrent(List *list);

/*--- r֐ɂēƂ݂Ȃm[h폜 ---*/
void Purge(List *list, int compare(const Member *x, const Member *y));

/*--- Sm[h폜 ---*/
void Clear(List *list);

/*--- ڃm[h̃f[^\ ---*/
void PrintCurrent(const List *list);

/*--- ڃm[h̃f[^\istj---*/
void PrintLnCurrent(const List *list);

/*--- Sm[h̃f[^\ ---*/
void Print(const List *list);

/*--- `Xǧn ---*/
void Terminate(List *list);

#endif
